// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 5.08.1103)
//  BCX (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005 by Kevin Diggins
// *************************************************************
//     Translated for compiling with a C Compiler
// *************************************************************
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <wchar.h>      // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #include <dos.h>
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif


#if !defined( __LCC__ )
// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************
#endif
// *************************************************
//            User Defined Constants
// *************************************************

#define bFlags WS_CHILD |WS_VISIBLE |BS_PUSHBUTTON 
#define icoXMAS 1
#define IDJOKE 2
#define midMEDLEY 3
#define curSANTA 4
#define IDCARD 5
#define IDABOUT 100
#define IDEXIT 101
#define IDPLAY 102
#define IDYUP 103
#define IDNET 104
#define GLOB_CLASS struct _GLOB*

// *************************************************
//          User Defined Types And Unions
// *************************************************

typedef struct _GLOB
{
HANDLE  Ctl;
RECT  Cell;
}GLOB, *LPGLOB;


// *************************************************
//                System Variables
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static float   BCX_ScaleX;
static float   BCX_ScaleY;
static HINSTANCE BCX_hInstance;
static HWND    BCX_hwndMDIClient;
static WNDCLASSEX   BCX_WndClass;
static BOOL    BCX_GUI_Init;
static char    BCX_ClassName[2048];
static HANDLE  hForm;
static HBITMAP hBMP;
static HANDLE  hCARD;
static HANDLE  hCur;
static HANDLE  mnuMain;
static HANDLE  mnuFile;
static POINT   pt;
static FILE*   FP1;
static GLOB    hOBJ[3];



// *************************************************
//               Standard Macros
// *************************************************

HFONT BcxFont=0;
#define DefaultFont ((BcxFont==0)?GetStockObject(DEFAULT_GUI_FONT):BcxFont)
#define Show(Window)RedrawWindow(Window,0,0,0);ShowWindow(Window,SW_SHOW);
#define PUT(A,B,C)fwrite(B,1,C,A)


// *************************************************
//               Standard Prototypes
// *************************************************

void    BCX_SetMetric (char *);
void    BCX_RegWnd (char *, WNDPROC);
void    BCX_InitGUI (void);
int     BCX_MDialog(DLGPROC,char*,HWND,int=0,int=0,int=250,int=150,int=0,int=0,char* =0,int=0);
void    SetDialogScale (HWND, BOOL);
HWND    BCX_Form(char*,int=0,int=0,int=250,int=150,int=0,int=0);
HWND    BCX_Button(char*,HWND,int=0,int=0,int=0,int=0,int=0,int=0,int=-1);
HWND    BCX_Bitmap(char*,HWND=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);
HWND    BCX_Icon(char*,HWND=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);
LPVOID  GetResource(int, char*, DWORD*);
HBITMAP BCX_LoadBMP (char *, int=0, int=0);
void    DrawTransBMP (HWND,HBITMAP,COLORREF,int,int,HDC=0);
void    Center (HWND,HWND=0,HWND=0);
char*   BCX_TmpStr(size_t);
char*   AppExePath (void);
SIZE*   GetTextSize (char*, HWND=0, HFONT=0);
char*   join (int, ... );

// *************************************************
//               User Prototypes
// *************************************************

void    About (void);
void    ShowCard (void);
BOOL    CALLBACK DialogProc (HWND, UINT, WPARAM, LPARAM);
void    Chase (HANDLE);
void    Santa (DWORD, DWORD);
void    IcoClick (DWORD, DWORD);
void    CleanUp (void);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
char    * FileFromRes (int);
BOOL    IsLoaded (char *);
void    MenuSetup (void);
void    Net (void);
void    FormLoad (void);

// **********************************

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
 MSG      Msg;
 BCX_SetMetric("pixels");
 BCX_hInstance       =  hInst;
 BCX_WndClass.hIcon  =  LoadIcon(BCX_hInstance,MAKEINTRESOURCE(1));
 BCX_RegWnd( "XMAS Bonus", WndProc );


 // ******************************************
                  FormLoad();
 // ******************************************

 while(GetMessage(&Msg,NULL,0,0))
   {
    HWND hActiveWindow = GetActiveWindow();
    if(!IsWindow(hActiveWindow) || !IsDialogMessage(hActiveWindow,&Msg))
      {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
      }
    }
 return Msg.wParam;
}


// *************************************************
//                 Runtime Functions
// *************************************************

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


char * join(int n, ...)
{
  register int i = n, tmplen = 0;
  register char *s_;
  register char *strtmp;
  va_list marker;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) tmplen += strlen(s_);
  }
  strtmp = BCX_TmpStr(tmplen);
  va_end(marker); // Reset variable arguments
  i = n;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) strcat(strtmp, s_);
  }
  va_end(marker); // Reset variable arguments
  return strtmp;
}


char *AppExePath (void)
{
 char *strtmp = BCX_TmpStr(2048);
 register int i;
 i=GetModuleFileName(GetModuleHandle(0),strtmp,2048);
 while(i && strtmp[i] != 0x5C)
   i--;
 strtmp[i+1] = 0;
 return strtmp;
}


void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
  RECT rect, rectP;
  int  x, y, width, height;
  int  screenwidth, screenheight;
  if(Xhwnd==0)
    {
      RECT  DesktopArea;
      RECT  rc;
      SystemParametersInfo(SPI_GETWORKAREA,0,&DesktopArea,0);
      GetWindowRect(hwnd,&rc);
      SetWindowPos(hwnd,HWND_TOP,
        ((DesktopArea.right-DesktopArea.left)-(rc.right-rc.left))/2+
          DesktopArea.left,((DesktopArea.bottom-DesktopArea.top)-
         (rc.bottom-rc.top))/2 + DesktopArea.top,0,0,SWP_NOSIZE);
      return;
    }
  GetWindowRect (hwnd,&rect);
  GetWindowRect (Xhwnd,&rectP);
  width = rect.right-rect.left;
  x = ((rectP.right-rectP.left)-width)/2 + rectP.left;
  if(Yhwnd==NULL)
    {
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2 + rectP.top;
    }
  else
    {
      GetWindowRect(Yhwnd,&rectP);
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2+rectP.top;
    }
  screenwidth = GetSystemMetrics(SM_CXSCREEN);
  screenheight = GetSystemMetrics(SM_CYSCREEN);
  if ((x<0)) x=0;
  if ((y<0)) y=0;
  if ((x+width>screenwidth))   x = screenwidth-width;
  if ((y+height>screenheight)) y = screenheight-height;
  MoveWindow (hwnd, x, y, width, height, FALSE);
}


int BCX_MDialog (DLGPROC DPro,char* title,HWND hWnd,int X,int Y,int W,int H,int Style,int Exstyle,char *fntface,int fsz)
{
  LPDLGTEMPLATE  lpdt;
  LPWORD  lpw;
  LPVOID tc=calloc(256+(strlen(title)*2),1);
  lpdt=(LPDLGTEMPLATE)tc;
  if(!Style)
   {
     lpdt->style=WS_POPUP|WS_SYSMENU|DS_MODALFRAME|WS_CAPTION;
     if(fsz) lpdt->style=lpdt->style|DS_SETFONT;
   }else{
     lpdt->style=Style;
   }
  lpdt->dwExtendedStyle=Exstyle;
  lpdt->cdit=0;
  lpdt->x =X;  lpdt->y =Y;
  lpdt->cx=W;  lpdt->cy=H;
  
  lpw=(LPWORD)(lpdt+1);
  *lpw++=0; *lpw++=0;
  lpw+=MultiByteToWideChar(CP_ACP,0,title,-1,(LPWSTR)lpw,2*strlen(title)+1);
  if(fsz) { *lpw++ = fsz;
  MultiByteToWideChar(CP_ACP,0,fntface,-1,(LPWSTR)lpw,2*strlen(fntface)+1); }
  int ret=DialogBoxIndirect(BCX_hInstance,(LPDLGTEMPLATE)tc,hWnd,(DLGPROC)DPro);
  free(tc);
  SetDialogScale(0,1);  //restore previous scale
  return ret;
}


void SetDialogScale (HWND hdlg, BOOL Restor)
{
 static float BaseX, BaseY;
 if(Restor&&BaseX)
  {
    BCX_ScaleX=BaseX;
    BCX_ScaleY=BaseY;
    return;
  }
 BaseX=BCX_ScaleX; BaseY=BCX_ScaleY;  
 RECT rc = {0, 0, 4, 8};
 MapDialogRect (hdlg, &rc);
 BCX_ScaleX = (float)rc.right/4;
 BCX_ScaleY = (float)rc.bottom/8;
}


HWND BCX_Form(char *Caption,int X,int Y,int W,int H,int Style,int Exstyle)
{
  if(!Style)
    {
       Style= WS_MINIMIZEBOX | WS_SIZEBOX | WS_CAPTION |
              WS_MAXIMIZEBOX | WS_POPUP   | WS_SYSMENU;
    }
  HWND A = CreateWindowEx(Exstyle,BCX_ClassName,Caption,Style,
                          X*BCX_ScaleX,Y*BCX_ScaleY,(4+W)*BCX_ScaleX,(12+H)*BCX_ScaleY,
                          NULL,(HMENU)NULL,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


HWND BCX_Button(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{ 
  if(!Style)
    {
      Style=WS_CHILD | WS_VISIBLE | BS_MULTILINE | BS_PUSHBUTTON | WS_TABSTOP;
    }
  if(Exstyle==-1)
    {
      Exstyle=WS_EX_STATICEDGE;
    }
  HWND A = CreateWindowEx(Exstyle,"button",Text,Style,
                          X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
                          hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  if (W==0)
    {
      SIZE*  size=GetTextSize(Text,A);
      MoveWindow(A,X*BCX_ScaleX,Y*BCX_ScaleY,size->cx+24,size->cy+12,TRUE);
    }
  return A;
}


HWND BCX_Bitmap(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Res,int Style,int Exstyle)
{
  HWND A;
  HBITMAP hBitmap=NULL;
   if(!Style) Style=WS_CLIPSIBLINGS|WS_CHILD|WS_VISIBLE|SS_BITMAP|WS_TABSTOP;
   A = CreateWindowEx(Exstyle,"static",NULL,Style,
                      X*BCX_ScaleX, Y*BCX_ScaleY,W*BCX_ScaleX, H*BCX_ScaleY,
                      hWnd,(HMENU)id,BCX_hInstance,NULL);
   if(Res)
      hBitmap=(HBITMAP)LoadImage(GetModuleHandle(0),MAKEINTRESOURCE(Res),IMAGE_BITMAP,
                                 W*BCX_ScaleX,H*BCX_ScaleY,LR_CREATEDIBSECTION);
   else if(Text!=NULL)
     {
       if(*Text)
         hBitmap=(HBITMAP)LoadImage(0,Text,IMAGE_BITMAP,W*BCX_ScaleX,H*BCX_ScaleY,
                                    LR_LOADFROMFILE|LR_CREATEDIBSECTION);
     }
   if(hBitmap)
     SendMessage(A,(UINT)STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBitmap);
  return A;
}


HWND BCX_Icon(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Res,int Style,int Exstyle)
{
  HICON hIcon;
  DWORD dwSize;
  LPBYTE pBytes;
  if(!Style) Style=WS_CHILD | WS_VISIBLE | SS_ICON | WS_TABSTOP;
  HWND A = CreateWindowEx(Exstyle,"static",NULL,Style,
           X*BCX_ScaleX, Y*BCX_ScaleY, 0, 0,
           hWnd,(HMENU)id,BCX_hInstance,NULL);
  if(!Res)
    hIcon=(HICON)LoadImage(0,Text,IMAGE_ICON,W,H,LR_LOADFROMFILE);
  else
   {
     pBytes=(PBYTE)GetResource(Res,RT_ANICURSOR,&dwSize);
     if(pBytes==NULL)
       hIcon=(HICON)LoadImage
             (BCX_hInstance,MAKEINTRESOURCE(Res),IMAGE_ICON,W,H,0);
     else
       hIcon=CreateIconFromResourceEx
             (pBytes,dwSize,FALSE,0x00030000,W,H,LR_DEFAULTCOLOR);
   }
  SendMessage(A,(UINT)STM_SETIMAGE,(WPARAM)IMAGE_ICON,(LPARAM)hIcon);
  return A;
}


LPVOID GetResource(int Res, char *ResType, DWORD *ResSize)
{
  HRSRC hRes;
  HMODULE hMod=GetModuleHandle(NULL);
  hRes=FindResource(hMod,MAKEINTRESOURCE(Res),ResType);
  if(hRes==NULL) return 0;
  if(ResSize) *ResSize=SizeofResource(hMod,hRes);
  return LockResource(LoadResource(hMod,hRes));
}


SIZE* GetTextSize(char* text, HWND hWnd, HFONT fnt)
{
  HDC  hdc=GetDC(hWnd);
  if(!fnt) fnt=(HFONT)SendMessage(hWnd,WM_GETFONT,0,0);
  HFONT sobj=(HFONT)SelectObject(hdc,fnt);
  static SIZE sz;
  GetTextExtentPoint32(hdc,text,strlen(text),&sz);
  SelectObject(hdc,sobj);
  ReleaseDC(hWnd,hdc);
  return (&sz);
}


HBITMAP BCX_LoadBMP (char *F, int i, int t)
{
 if(t) t=LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS;
 if(i)
   return (HBITMAP)LoadImage(GetModuleHandle(0), MAKEINTRESOURCE(i),IMAGE_BITMAP,0,0,t);
   return (HBITMAP)LoadImage(NULL,F,IMAGE_BITMAP,0,0,LR_LOADFROMFILE|t);
}


void DrawTransBMP (HWND hWnd,HBITMAP hBitmap,COLORREF cTransparentColor,int xStart,int yStart,HDC hdc)
{
  BITMAP bm;
  COLORREF cColor;
  HBITMAP bmAndBack, bmAndObject, bmAndMem,bmSave;
  HBITMAP bmBackOld, bmObjectOld, bmMemOld,bmSaveOld,hmTMP;
  HDC hdcMem, hdcBack, hdcObject,hdcTemp, hdcSave;
  POINT ptSize;
  int b=0;
  if(!hdc) hdc=GetDC(hWnd),b=1;
  hdcTemp = CreateCompatibleDC(hdc);
  SelectObject(hdcTemp, hBitmap);
  GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
  ptSize.x = bm.bmWidth;
  ptSize.y = bm.bmHeight;
  DPtoLP(hdcTemp, &ptSize, 1);
  hdcBack = CreateCompatibleDC(hdc);
  hdcObject = CreateCompatibleDC(hdc);
  hdcMem = CreateCompatibleDC(hdc);
  hdcSave = CreateCompatibleDC(hdc);
  bmAndBack = CreateBitmap(ptSize.x,ptSize.y, 1, 1, NULL);
  bmAndObject = CreateBitmap(ptSize.x,ptSize.y, 1, 1, NULL);
  bmAndMem = CreateCompatibleBitmap(hdc,ptSize.x, ptSize.y);
  bmSave = CreateCompatibleBitmap(hdc,ptSize.x, ptSize.y);
  bmBackOld = (HBITMAP)SelectObject(hdcBack,bmAndBack);
  bmObjectOld = (HBITMAP)SelectObject(hdcObject,bmAndObject);
  bmMemOld = (HBITMAP)SelectObject(hdcMem,bmAndMem);
  bmSaveOld = (HBITMAP)SelectObject(hdcSave,bmSave);
  SetMapMode(hdcTemp, GetMapMode(hdc));
  BitBlt(hdcSave, 0, 0, ptSize.x, ptSize.y,hdcTemp, 0, 0, SRCCOPY);
  cColor = SetBkColor(hdcTemp,cTransparentColor);
  BitBlt(hdcObject, 0, 0, ptSize.x, ptSize.y,hdcTemp, 0, 0, SRCCOPY);
  SetBkColor(hdcTemp, cColor);
  BitBlt(hdcBack, 0, 0, ptSize.x, ptSize.y,hdcObject, 0, 0, NOTSRCCOPY);
  BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y,hdc, xStart, yStart, SRCCOPY);
  BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y,hdcObject, 0, 0, SRCAND);
  BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y,hdcBack, 0, 0, SRCAND);
  BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y,hdcTemp, 0, 0, SRCPAINT);
  BitBlt(hdc, xStart, yStart, ptSize.x,ptSize.y, hdcMem, 0, 0,SRCCOPY);
  BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y,hdcSave, 0, 0, SRCCOPY);
  hmTMP = (HBITMAP)SelectObject(hdcBack, bmBackOld);
  DeleteObject(hmTMP);
  hmTMP = (HBITMAP)SelectObject(hdcObject,bmObjectOld);
  DeleteObject(hmTMP);
  hmTMP = (HBITMAP)SelectObject(hdcMem, bmMemOld);
  DeleteObject(hmTMP);
  hmTMP = (HBITMAP)SelectObject(hdcSave, bmSaveOld);
  DeleteObject(hmTMP);
  DeleteDC(hdcMem);
  DeleteDC(hdcBack);
  DeleteDC(hdcObject);
  DeleteDC(hdcSave);
  DeleteDC(hdcTemp);
  if(b) ReleaseDC(hWnd,hdc);
}


void BCX_SetMetric (char *metric)
{
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(stricmp(metric,"PIXELS")==0)
    {
      BCX_ScaleX=1;
      BCX_ScaleY=1;
    }
  else
    {
      RECT  rc={0,0,4,8};
      MapDialogRect(NULL,&rc);
      BCX_ScaleX=rc.right/2;
      BCX_ScaleY=rc.bottom/4;
    }
}


void BCX_RegWnd (char *classname, WNDPROC Form_WndProc)
{
  if(classname[0]==0)
    {
      MessageBox (GetActiveWindow(),"Empty String For BCX_ClassName NOT Allowed","Empty ClassName",0);
      fflush(stdout);
      ExitProcess(1);
    }
  if(GetClassInfoEx( BCX_hInstance, classname, &BCX_WndClass)!=0)
    {
      if(!Form_WndProc)
        {
          UnregisterClass(classname,BCX_hInstance);
        }
      return;
    }
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(BCX_ScaleX==0&&BCX_ScaleY==0)
    {
      BCX_SetMetric("Pixels");
    }
  strcpy(BCX_ClassName,classname);
  BCX_WndClass.lpfnWndProc=Form_WndProc;
  BCX_WndClass.hInstance=BCX_hInstance;
  BCX_WndClass.lpszClassName=classname;
  RegisterClassEx(&BCX_WndClass);
}


void BCX_InitGUI (void)
{
  INITCOMMONCONTROLSEX  iccex;
  if(BCX_GUI_Init)
    {
      return;
    }
  BCX_ScaleX=1;
  BCX_ScaleY=1;
  BCX_hInstance=GetModuleHandle(NULL);
  BCX_hwndMDIClient=NULL;
  BCX_WndClass.cbSize=sizeof(BCX_WndClass);
  BCX_WndClass.style=CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
  BCX_WndClass.cbClsExtra=0;
  BCX_WndClass.cbWndExtra=0;
  BCX_WndClass.hIcon= LoadIcon(BCX_hInstance,MAKEINTRESOURCE(1));;
  BCX_WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
  BCX_WndClass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
  BCX_WndClass.lpszMenuName=NULL;
  BCX_WndClass.hIconSm=NULL;
  iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
  iccex.dwICC=ICC_LISTVIEW_CLASSES | ICC_TREEVIEW_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_UPDOWN_CLASS | ICC_PROGRESS_CLASS | ICC_USEREX_CLASSES | ICC_DATE_CLASSES;
  InitCommonControlsEx(&iccex);
  BCX_GUI_Init=TRUE;
}



// ************************************
//       User Subs and Functions
// ************************************


void About (void)
{
  MessageBox (GetActiveWindow(),"XMAS Bonus 2005 Michael S. Sanders  All Rights Reserved.","XMAS Bonus v1.00",0);
}


void ShowCard (void)
{
  BCX_MDialog(DialogProc,"Season's Greetings!",hForm,0,0,352/2,240/2);
}


BOOL CALLBACK DialogProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  while(1)
  {
    if(Msg==WM_INITDIALOG)
      {
        SetDialogScale(hWnd,0);
        hCARD=BCX_Bitmap(0,hWnd,800,0,0,352/2,240/2,IDCARD);
        Center(hWnd);
        Show(hWnd);
        SetFocus(hCARD);
        break;
      }
    if(Msg==WM_COMMAND||Msg==WM_LBUTTONDOWN||Msg==WM_RBUTTONDOWN)
      {
        EndDialog(hWnd,0);
      }
    break;
  }
  if(Msg==WM_CLOSE) EndDialog(hWnd,0);
  return 0;
}


void Chase (HANDLE Ctl)
{
  if(Ctl==hOBJ[2].Ctl)
    {
      if(hOBJ[2].Cell.left==308)
        {
          MoveWindow(hOBJ[2].Ctl,144,60,75,26,1);
          SetRect(&hOBJ[2].Cell,144,60,144+75,60+26);
        }
      else
        {
          MoveWindow(hOBJ[2].Ctl,308,60,75,26,1);
          SetRect(&hOBJ[2].Cell,308,60,308+75,60+26);
        }
    }
}


void Santa (DWORD x, DWORD y)
{
  pt.x=x;
  pt.y=y;
  if(PtInRect(&hOBJ[0].Cell,pt))
    {
      SetCursor(hCur);
    }
}


void IcoClick (DWORD x, DWORD y)
{
  pt.x=x;
  pt.y=y;
  if(PtInRect(&hOBJ[0].Cell,pt))
    {
      SetCursor(hCur);
      ShellExecute(0,"open",FileFromRes(midMEDLEY),0,AppExePath(),1);
    }
}


void CleanUp (void)
{
  DeleteObject(hBMP);
  DeleteObject(hCARD);
  free(hOBJ);
  DestroyWindow(hForm);
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  while(1)
  {
    if(Msg==WM_CREATE)
      {
        if(IsLoaded("XMAS Bonus"))
          {
            PostQuitMessage(0);
          }
        break;
      }
    if(Msg==WM_MOUSEMOVE)
      {
        Santa(LOWORD(lParam),HIWORD(lParam));
        break;
      }
    if(Msg==WM_SETCURSOR)
      {
        Chase((HWND)wParam);
        break;
      }
    if(Msg==WM_LBUTTONDOWN)
      {
        IcoClick(LOWORD(lParam),HIWORD(lParam));
        break;
      }
    if(Msg==WM_CLOSE)
      {
        CleanUp();
        break;
      }
    if(Msg==WM_DESTROY)
      {
        PostQuitMessage(0);
        break;
      }
    if(Msg==WM_PAINT)
      {
        DrawTransBMP(hForm,hBMP,RGB(255,255,255),52,14);
        break;
      }
    if(Msg==WM_COMMAND)
      {
        while(1)
        {
          if(LOWORD(wParam)==IDABOUT)
            {
              About();
              break;
            }
          if(LOWORD(wParam)==IDEXIT)
            {
              CleanUp();
              break;
            }
          if(LOWORD(wParam)==IDPLAY)
            {
              ShellExecute(0,"open",FileFromRes(midMEDLEY),0,AppExePath(),1);
              break;
            }
          if(LOWORD(wParam)==IDYUP)
            {
              ShowCard();
              break;
            }
          if(LOWORD(wParam)==IDNET)
            {
              Net();
            }
          break;
        }
      }
    break;
  }
  if(Msg==WM_DESTROY)
    {
       PostQuitMessage(0);
       return 0;
    }
 return DefWindowProc(hWnd,Msg,wParam,lParam);
}


char * FileFromRes (int ResID)
{
  char *BCX_RetStr={0};
  DWORD  dd;
  LPSTR  temp;
  if((FP1=fopen(join(2,AppExePath(),"Medley.mid"),"wb+"))==0)
   {
  fprintf(stderr,"Can't open file %s\n",join(2,AppExePath(),"Medley.mid"));exit(1);
   }
  temp=GetResource(ResID,RT_RCDATA,&dd);
  PUT(FP1,temp,dd);
  if(FP1)
   {
     fclose(FP1);
     FP1=NULL;
   }
  BCX_RetStr=BCX_TmpStr(strlen("Medley.mid"));
  strcpy(BCX_RetStr,"Medley.mid");
  return BCX_RetStr;
}


BOOL IsLoaded (char *UniqueId)
{
  if(OpenMutex(MUTEX_ALL_ACCESS,0,UniqueId)!=0)
    {
      return TRUE;
    }
  else
    {
      CreateMutex(0,1,UniqueId);
      return FALSE;
    }
}


void MenuSetup (void)
{
  mnuMain=CreateMenu();
  mnuFile=CreateMenu();
  AppendMenu(mnuFile,MF_STRING,IDPLAY,"Christmas Medley");
  AppendMenu(mnuFile,MF_SEPARATOR,0,0);
  AppendMenu(mnuFile,MF_STRING,IDABOUT,"About");
  AppendMenu(mnuFile,MF_STRING,IDNET,"Web Site");
  AppendMenu(mnuFile,MF_SEPARATOR,0,0);
  AppendMenu(mnuFile,MF_STRING,IDEXIT,"Exit");
  InsertMenu(mnuMain,0,MF_POPUP,(UINT)mnuFile,"File");
  SetMenu(hForm,mnuMain);
}


void Net (void)
{
  ShellExecute(0,"open","http://fuzzbox.hypermart.net",0,0,1);
}


void FormLoad (void)
{
  hCur=LoadCursor(BCX_hInstance,MAKEINTRESOURCE(curSANTA));
  hBMP=BCX_LoadBMP(0,IDJOKE);
  hForm=BCX_Form("XMAS Bonus",0,0,392,136,WS_CAPTION|WS_SYSMENU);
  MenuSetup();
  hOBJ[0].Ctl=BCX_Icon(0,hForm,1001,10,10,32,32,icoXMAS);
  hOBJ[0].Cell.left=10;
  hOBJ[0].Cell.top=10;
  hOBJ[0].Cell.right=42;
  hOBJ[0].Cell.bottom=42;
  hOBJ[1].Ctl=BCX_Button("Yes",hForm,IDYUP,226,60,75,26,bFlags,WS_EX_WINDOWEDGE);
  hOBJ[2].Ctl=BCX_Button("No",hForm,0,308,60,75,26,bFlags,WS_EX_WINDOWEDGE);
  hOBJ[2].Cell.left=308;
  hOBJ[2].Cell.top=60;
  hOBJ[2].Cell.right=308+75;
  hOBJ[2].Cell.bottom=60+26;
  Center(hForm);
  Show(hForm);
}


